#include "stdafx.h"
#include "NeMessenger.h"
#include "AddUserDlg.h"
#include "WorkGroupController.h"
#include "WorkGroupModel.h"
#include "NeMessengerDlg.h"
#include "MemoSendDlg.h"
#include "ChatDlg.h"
#include "DialPadDlg.h"
#include "main_frame.hpp"
const int colWidthListUser[] = {
	21,		// üũ
	24,		// 
	50,		// ̸
	90,		// μ
	48,		// 
	40,		// ٹ 
	-1
};		

const int colWidthListUser_NotWorkStatus[] = {
	21,		// üũ
	24,		// 
	50,		// ̸
	90,		// μ
	48,		// 
	-1
};	

IMPLEMENT_DYNAMIC(CAddUserDlg, CDialog)

CAddUserDlg::CAddUserDlg(WorkGroupController* pController, WorkGroupModel* pModel, CWnd* pParent, int nType)
	: CDialog(CAddUserDlg::IDD, pParent)
	, m_pParent(pParent)
	, m_pController(pController)
	, m_pModel(pModel)
{
	m_strSearchText = _T("");
	m_userDataVector.clear();
	m_nParentType = nType;
	m_bSortAscending = true;
}

CAddUserDlg::~CAddUserDlg()
{
	m_bmTopBg.DeleteObject();
	m_penBorder.DeleteObject();
	m_ImageList.DeleteImageList();
	m_ImageListWorkStatus.DeleteImageList();

	FreeListData();
    m_pController = NULL;
    m_pModel = NULL;
    m_pParent = NULL;
}

void CAddUserDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_USER, m_lcUser);
	DDX_Control(pDX, IDOK, m_bnOK);
	DDX_Control(pDX, IDCANCEL, m_bnCancel);
}


BEGIN_MESSAGE_MAP(CAddUserDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_USER, &CAddUserDlg::OnNMDblclkListUser)
	ON_NOTIFY(NM_CLICK, IDC_LIST_USER, &CAddUserDlg::OnNMClickListUser)
	ON_NOTIFY(HDN_ITEMCLICK, 0, &CAddUserDlg::OnHdnItemclickList)
	ON_MESSAGE(UM_CHAT_GET_STATUS,&CAddUserDlg::OnGetUserStatus)
END_MESSAGE_MAP()


BOOL CAddUserDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	if (m_nParentType == ADD_USER_FROM_TOPMENU_CALLTRANSFER || m_nParentType == ADD_USER_FROM_DIALPAD)
		SetWindowText(LoadStringFromResource(IDS_IPT_CALLTRANSFER));	// ȣ ȯ
	else
	{
		
		SetWindowText(LoadStringFromResource(IDS_STRING267));			//  ߰
	}

	ModifyStyle(0, WS_CLIPCHILDREN);
	m_lcUser.ModifyStyle(0, LVS_SINGLESEL);
    m_lcUser.SetEnableItemToolTips(FALSE);
	//m_lcUser.SetTrackHoverFlag(true);

	// Ʈ  ̹ Ʈ
	if (m_ImageList.Create(24, 18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 14, 3))
	{
		COLORREF crMask = RGB(0, 0, 0);

		const BYTE nStatusCnt = 14;
		for( BYTE i = 0; i < nStatusCnt; i++ )
		{
			CString strImageFilePath = GET_APP()->GetBuddyPresenceImageFilePath( (GTUserStatusType)(i > ustMEETING ? i - (ustMEETING+1) | ustMOBILE : i));

			CBitmap bmStatus;
			LoadBitmapFromPath(bmStatus, strImageFilePath);
			m_ImageList.Add(&bmStatus, crMask);
			bmStatus.DeleteObject();
		}
	}
	if (m_ImageListWorkStatus.Create(18,18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 2, 2))
	{
		COLORREF crMask = RGB(0, 0, 0);

		const BYTE nStatusCnt = 2;
		for( BYTE i = 0; i < nStatusCnt; i++ )
		{
			CString strImageFilePath = GET_APP()->GetWorkStatusImageFilePath();

			CBitmap bmStatus;
			LoadBitmapFromPath(bmStatus, strImageFilePath);
			m_ImageListWorkStatus.Add(&bmStatus, crMask);
			bmStatus.DeleteObject();
		}
	}

	// Ʈ ÷  
	m_arListHeaderTitle.Add(_T(""));								// üũ ڽ
	m_arListHeaderTitle.Add(_T(""));								//  
	m_arListHeaderTitle.Add(LoadStringFromResource(IDS_STRING142));	// ̸
	m_arListHeaderTitle.Add(LoadStringFromResource(IDS_STRING143));	// Ҽ
	m_arListHeaderTitle.Add(LoadStringFromResource(IDS_STRING268));	// 
								// 

	//  Ʈ
	m_lcUser.SetImageList(&m_ImageList, LVSIL_SMALL);

	if (GET_CONFIG()->EnableFunction(_T("UI_01")))
	{
		m_arListHeaderTitle.Add(LoadStringFromResource(IDS_STRING635));	
		InitList(m_lcUser, m_arListHeaderTitle);
		ResizeListColumn(m_lcUser, colWidthListUser);
		m_lcUser.SetImageColumn(1);
		m_lcUser.SetWorkStatusColumn(5);
		m_lcUser.SetWorkStatusImageList(&m_ImageListWorkStatus);
	}
	else
	{
		InitList(m_lcUser, m_arListHeaderTitle);
		ResizeListColumn(m_lcUser, colWidthListUser_NotWorkStatus);
		m_lcUser.SetImageColumn(1);

	}



	//  ˻ Ʈ/ư
	CString strTmpClassName;
	strTmpClassName.Format(_T("Ntalk_AddUserDlg_Search_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());
	RegisterWindowClass(strTmpClassName);

	CRect rtWorkSearch(0, 0, 0, 0);
	if (m_wndSearch.Create(strTmpClassName, _T("Ntalk_AddUser_Search"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS, rtWorkSearch, this, ID_ADD_USER_SEARCH))
	{
		m_wndSearch.SetImgBGPath(_T("Main_searchform_bg.png"));
		m_wndSearch.SetImgSearchPath(_T("New_Info_Search.png"), _T("New_Info_Search_Over.png"), _T("New_Info_Search_Click.png"));
		m_wndSearch.SetDefaultText(LoadStringFromResource(IDS_STRING245));
		m_wndSearch.SetEditBkColor(RGB(255, 255, 255));
		m_wndSearch.SetEditFont(&g_ftDefault9PT);
		if (m_strSearchText.IsEmpty())
			m_wndSearch.SetIntroducingText();
		else 
			m_wndSearch.SetIntroducingText(m_strSearchText);

		m_wndSearch.SetSearchText(m_strSearchText);
		m_wndSearch.SetResetSearchText(FALSE);		// ˻  ˻ ʱȭ  
	}

	// â  
	m_penBorder.CreatePen(PS_SOLID, 1, COLOR_LIST_BORDER);

	// ĸǹ Ʒ ׶̼  ̹
	LoadBitmapFromPath(m_bmTopBg, GetAppImgFile(_T("frame_B_bg.png")));

	//  â 
	MoveWindow(0, 0, 320, 380);
	CenterWindow();
	SetSkin();
	__ResourceLoad(TRUE);
	ReSizeCtrl();
	RedrawWindow();

	//m_wndSearch.m_edit.SetFocus();
	m_wndSearch.SetEditSearch(TRUE);
	if(m_nParentType == ADD_USER_FROM_CHAT)
	{
		SetWindowText( LoadStringFromResource(IDS_ADD_CHAT_USER));
	}
	
	return FALSE;
}

void CAddUserDlg::SetSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("AddUserDlg.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CAddUserDlg::ReSizeCtrl()
{
    CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);	

	// Search Window
	if (m_wndSearch.GetSafeHwnd())
	{
		int nImgWidth = m_wndSearch.GetImgBGWidth();
		int nImgHeight = m_wndSearch.GetImgBGHeight();

		CRect rtSearch(0, 0, 0, 0);
		rtSearch.top = rcClient.top + 4;
		rtSearch.bottom = rtSearch.top + nImgHeight;
		rtSearch.left = 16;
		rtSearch.right = rcClient.right - 16;

		m_wndSearch.MoveWindow(&rtSearch);
	}

	// List
	if (m_lcUser.GetSafeHwnd())
	{
		m_lcUser.MoveWindow(16, rcClient.top + 50, rcClient.Width() - 32, rcClient.Height() - 110);
	}

	// Button
	if (m_bnOK.GetSafeHwnd() && m_bnCancel.GetSafeHwnd())
	{
		CRect rcBtn(0, 0, 0, 0);
		rcBtn.left = (rcClient.Width() / 2) - (ADD_USER_DLG_BTN_GAP_X / 2) - ADD_USER_DLG_BTN_WIDTH;
		rcBtn.right = rcBtn.left + ADD_USER_DLG_BTN_WIDTH;
		rcBtn.bottom = rcClient.bottom - 7;
		rcBtn.top = rcBtn.bottom - ADD_USER_DLG_BTN_HEIGHT;

		m_bnOK.MoveWindow(rcBtn, TRUE);
		m_bnOK.Invalidate();

		rcBtn.OffsetRect(ADD_USER_DLG_BTN_WIDTH + ADD_USER_DLG_BTN_GAP_X, 0);
		m_bnCancel.MoveWindow(rcBtn, TRUE);
		m_bnCancel.Invalidate();
	}
}

//UIʱȭ
void CAddUserDlg::InitList(CNListCtrl &list, CStringArray &strHeaderTitle)
{
	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_MINWIDTH;


	for (int i = 0; i < strHeaderTitle.GetCount(); i++)
	{
		lvcolumn.fmt = LVCFMT_LEFT;
		lvcolumn.pszText = (LPTSTR)(LPCTSTR)strHeaderTitle.GetAt(i);
		lvcolumn.iSubItem = i;
		lvcolumn.cxMin = 0;
		list.InsertColumn(i, &lvcolumn);
	}

	list.SetExtendedStyle(LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT | LVS_EX_DOUBLEBUFFER | LVS_EX_SUBITEMIMAGES);
	list.SetRowHeight(19);			// Ʈ   
	list.SetTextFont(&g_ftDefault8PT);	// Ʈ Ʈ 
	list.GetHeaderCtrl()->SetFont(&g_ftDefault8PT);
	list.AddCheckBoxForHeadCtrl();
}

void CAddUserDlg::ResizeListColumn(CNListCtrl &list, const int *arrWidth)
{
	for (int i = 0; arrWidth[i] != -1; i++)
	{
		list.SetColumnWidth(i, arrWidth[i]);
	}

	list.RedrawWindow();
}

void CAddUserDlg::InitMemberList()
{
	FreeListData();
	m_lcUser.DeleteAllItems();
	m_lcUser.ShowEmptyText(true);

	if (NULL != m_pModel)
	{
		const std::vector<ORG_MEMBER_DATA> memberVector = m_pModel->GetSelectedUserVector();
		for (size_t i = 0; i < memberVector.size(); i++)
		{
			NE_MEMBER_DATA sMemberInfo = memberVector[i].neMemberData;
			LVITEM lvItem;
			lvItem.mask = LVIF_IMAGE;
			lvItem.iItem = i;
			lvItem.iSubItem = 0;
			lvItem.iImage = memberVector[i].eStatus;

			m_lcUser.InsertItem(&lvItem);

			//  ¾  
			if (m_pController->IsMyID(sMemberInfo.strUserId.c_str()))
			{
				GTUserStatusType myStatus = GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus();
				m_pModel->UpdateMemberStatus(sMemberInfo.strUserId.c_str(), myStatus);
				m_lcUser.SetItemImage(i, 0, m_pController->GetImageIndexFromStatus(myStatus));
			}
			else
				m_lcUser.SetItemImage(i, 0, 0);

			m_lcUser.SetItemText(i, 2, sMemberInfo.strName.c_str());
			m_lcUser.SetItemText(i, 3, sMemberInfo.strDept.c_str());
			m_lcUser.SetItemText(i, 4, sMemberInfo.strJobPos.c_str());
			if (GET_CONFIG()->EnableFunction(_T("UI_01")))
			{
				CString strToolTip = sMemberInfo.strWorkStatus.c_str();
				strToolTip.Replace(_T(":"),_T("\n"));
				m_lcUser.SetItemText(i, 5, strToolTip);
			}

			CAddUserListData *pListData = new CAddUserListData(sMemberInfo);
			if (NULL != pListData)
			{
				m_lcUser.SetItemData(i, (DWORD_PTR)pListData);
				m_userDataVector.push_back(pListData);
			}
		}

		vector<wstring> vecUsers;
		std::vector<ORG_MEMBER_DATA>::const_iterator itr = memberVector.begin();
		for(; itr != memberVector.end(); itr++)
			vecUsers.push_back(itr->neMemberData.strUserId);

		g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_ADDUSERDLG);
	}

	m_lcUser.RedrawWindow();
}

void CAddUserDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));	// ȭ 

	//  ̹
	BITMAP bitmap;
	m_bmTopBg.GetBitmap(&bitmap);

	NMMemDC memBmpDC;
	memBmpDC.CreateCompatibleDC(&dc, bitmap.bmWidth, bitmap.bmHeight);

	CBitmap *pOldBmp = memBmpDC.SelectObject(&m_bmTopBg);
	memDC.StretchBlt(0, 0, rcClient.Width(), bitmap.bmHeight, &memBmpDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCCOPY);
	memBmpDC.SelectObject(pOldBmp);

	// Search wnd  â   ϴٺ ¿  Ƿ ׷ش.
	CRect rcSearch(0, 0, 0, 0);
	m_wndSearch.GetWindowRect(rcSearch);
	this->ScreenToClient(rcSearch);
	rcSearch.InflateRect(1, 0, 1, 0);
	memDC.FillSolidRect(rcSearch.left, rcSearch.top, rcSearch.Width(), rcSearch.Height(), COLOR_LIST_BORDER);

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.SelectObject((HBRUSH)GetStockObject(NULL_BRUSH));

	// Listctrl 漱
	CRect rcList(0, 0, 0, 0);
	m_lcUser.GetWindowRect(&rcList);
	ScreenToClient(rcList);
	rcList.InflateRect(1, 1, 1, 1);
	memDC.Rectangle(rcList);

	// ϴ μ
	memDC.MoveTo(0, rcClient.bottom - 49);
	memDC.LineTo(rcClient.right, rcClient.bottom - 49);

	// memDC  ׸  ѹ DC ׷  .
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldPen);
}

BOOL CAddUserDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int nID = LOWORD(wParam);

	switch (nID)
	{
	case ID_ADD_USER_SEARCH:
		{
			CString strSearchText = m_wndSearch.GetSearchText();
			DoSearch(strSearchText);
		}
		break;
	}

	return CDialog::OnCommand(wParam, lParam);
}

void CAddUserDlg::DoSearch(CString strSearchText)
{
	strSearchText = strSearchText.Trim(_T("% "));	// յ %  ڴ Ѵ.

	if (strSearchText.GetLength() < 2)
	{
		CString strString;
		strString.LoadString(IDS_STRING169);
		NMessageBox(this, strString);

		m_wndSearch.SetIntroducingText(m_wndSearch.GetSearchText());
		
		return;
	}

	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ADDUSERDLG);

	m_wndSearch.SetIntroducingText(strSearchText);
	m_wndSearch.SetSearchText(strSearchText);
	m_pController->RequestAddUserSearchList(strSearchText);
}

void CAddUserDlg::UpdateMemberStatus(LPCWSTR strUserId)
{
	int nItemCount = m_lcUser.GetItemCount();

	for (int i = 0; i < nItemCount; i++)
	{
		CAddUserListData *pData = (CAddUserListData*)m_lcUser.GetItemData(i);

		if (!pData)
			continue;

		CString strID = pData->GetUserID();

		if (NULL != m_pModel && strID.Compare(strUserId) == 0)
		{
			m_lcUser.SetItemImage(i, 0, m_pController->GetImageIndexFromStatus(m_pModel->GetMemberStatus(strUserId)));
		}
	}
}

void CAddUserDlg::FreeListData()
{
	std::vector<CAddUserListData *>::iterator iter;

	for (iter = m_userDataVector.begin(); iter != m_userDataVector.end(); iter++)
	{
		CAddUserListData *pData = (CAddUserListData *)*iter;
		SAFE_DELETE(pData);
	}

	m_userDataVector.clear();
}

bool CAddUserDlg::SendUserListToParent()
{
	std::vector<NE_MEMBER_DATA> selectedUserVector;
	int nItemCount = m_lcUser.GetItemCount();

	for (int i = 0; i < nItemCount; i++)
	{
		if (m_lcUser.GetCheck(i))
		{
			CAddUserListData *pData = (CAddUserListData*)m_lcUser.GetItemData(i);

			if (!pData)
				continue;

			selectedUserVector.push_back(pData->GetMemberData());
			//m_lcUser.SetCheck(i, FALSE);
		}
	}

	if (selectedUserVector.size() > 0)
	{
		if (m_nParentType == ADD_USER_FROM_CHAT)
		{
			CChatDlg* pParent = (CChatDlg*)m_pParent;
			pParent->AddUser(selectedUserVector);

		}
		else if (m_nParentType == ADD_USER_FROM_NOTE)
		{
			CMemoSendDlg* pParent = (CMemoSendDlg*)m_pParent;
			pParent->AddUser(selectedUserVector);
		}
		else if (m_nParentType == ADD_USER_FROM_DIALPAD)
		{
			if( selectedUserVector.size() > 1 )
			{
				NMessageBox(this, LoadStringFromResource(IDS_STRING586));	
				return false;
			}

			if( selectedUserVector.begin()->strUserId == g_pMessengerActor->GetUserID() )
			{
				NMessageBox(this, LoadStringFromResource(IDS_STRING588));	
				return false;
			}

			if( selectedUserVector.begin()->strExtesion.empty() )
			{
				NMessageBox(this, LoadStringFromResource(IDS_STRING589));
				return false;
			}

			// ȣ ȯ     .
			CDialPadDlg* pParent = (CDialPadDlg*)m_pParent;
			pParent->SetTransferUser(selectedUserVector);

			CDialog::OnCancel();
		}
		else if (m_nParentType == ADD_USER_FROM_TOPMENU_CALLTRANSFER)
		{
			if( selectedUserVector.size() > 1 )
			{
				NMessageBox(this,  LoadStringFromResource(IDS_STRING586));	
				return false;
			}
			else if( selectedUserVector.begin()->strUserId == g_pMessengerActor->GetUserID() )
			{
				NMessageBox(this, LoadStringFromResource(IDS_STRING588));
				return false;
			}
			else if( selectedUserVector.begin()->strExtesion.empty() )
			{
				NMessageBox(this, LoadStringFromResource(IDS_STRING589));	
				return false;
			}
			else
			{
				g_pMessengerActor->RequestCallTransfer( g_pMessengerActor->GetUserID(), selectedUserVector.begin()->strUserId.c_str() );
			}

			CDialog::OnCancel();
		}
		else if (m_nParentType == ADD_USER_FROM_CONFERENCECALL)
		{
			if( selectedUserVector.size() > 1 )
			{
				NMessageBox(this,  LoadStringFromResource(IDS_STRING586));	
				return false;
			}
			else if( selectedUserVector.begin()->strUserId == g_pMessengerActor->GetUserID() )
			{
				NMessageBox(this, LoadStringFromResource(IDS_STRING588));	
				return false;
			}
			else if( selectedUserVector.begin()->strExtesion.empty() )
			{
				NMessageBox(this, LoadStringFromResource(IDS_STRING589));	
				return false;
			}
			else
			{
				g_pMessengerActor->RequestConferenceCall( g_pMessengerActor->GetUserID(), selectedUserVector.begin()->strExtesion.c_str() );
			}

			CDialog::OnCancel();
		}
	}

	return true;
}

void CAddUserDlg::OnOK()
{
	if( SendUserListToParent() )
		CDialog::OnOK();
}

void CAddUserDlg::OnCancel()
{
	CDialog::OnCancel();
}

void CAddUserDlg::ChangeMyStatus(GTUserStatusType eMyStatus)
{
	int nItemCount = m_lcUser.GetItemCount();

	for (int i = 0; i < nItemCount; i++)
	{
		CAddUserListData *pData = (CAddUserListData*)m_lcUser.GetItemData(i);

		if (!pData)
			continue;

		CString strID = pData->GetUserID();

		if (m_pController->IsMyID(strID))
		{
			m_pModel->UpdateMemberStatus(strID, eMyStatus);
			m_lcUser.SetItemImage(i, 0, m_pController->GetImageIndexFromStatus(eMyStatus));
			break;
		}
	}
}

BOOL CAddUserDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN)
		{
			return TRUE;
		}
	}
	else if (IsCloseMsg(pMsg))
	{
		m_pController->CloseAddUserDlg();
		return TRUE;
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CAddUserDlg::OnDestroy()
{
	CDialog::OnDestroy();

	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ADDUSERDLG);
}

bool CAddUserDlg::IsCloseMsg(MSG* pMsg)
{
	bool result = false;

	if (pMsg->hwnd != this->GetSafeHwnd())
		return false;

	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||									// ALT + F4
		(pMsg->message == WM_SYSCOMMAND && (pMsg->wParam & 0xFFF0) == SC_CLOSE) ||						// ŸƲ Ŭ޴ > ݱ
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
	{
		result = true;
	}

	return result;
}

void CAddUserDlg::OnNMDblclkListUser(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	if (pNMItemActivate->iItem >= 0)
	{
		m_lcUser.SetCheck(pNMItemActivate->iItem, TRUE);
		SendUserListToParent();
	}

	*pResult = 0;
}

void CAddUserDlg::OnNMClickListUser(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	
	Trace(_T("-----%d,%d\n"), pNMItemActivate->iItem, pNMItemActivate->iSubItem);

	if (pNMItemActivate->iItem < 0 || pNMItemActivate->iSubItem == 0)	// subItem 0  ڵ üũǹǷ 2 ó ʵ Ѵ.
		return;

	int nItem = pNMItemActivate->iItem; 
	BOOL bCheck = m_lcUser.GetCheck(nItem);
	m_lcUser.SetCheck(nItem, !bCheck);

	*pResult = 0;

}

void CAddUserDlg::__ResourceLoad(BOOL bInit)
{
	if (bInit == TRUE)
	{
		if (m_bnOK.GetSafeHwnd())
		{
			m_bnOK.SetFont(&g_ftDefault12PX);
		}
		if (m_bnCancel.GetSafeHwnd())
		{
			m_bnCancel.SetFont(&g_ftDefault12PX);
		}
	}

	SetWindowText(LoadStringFromResource(IDS_STRING567));

	if (m_bnOK.GetSafeHwnd())
		m_bnOK.SetWindowText(LoadStringFromResource(IDS_STRING568));

	if (m_bnCancel.GetSafeHwnd())
		m_bnCancel.SetWindowText(LoadStringFromResource(IDS_STRING569));

	if (m_wndSearch.GetSafeHwnd())
		m_wndSearch.SetDefaultText(LoadStringFromResource(IDS_STRING245));

	if (bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);
}

void CAddUserDlg::OnHdnItemclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLISTVIEW *pLV = (NMLISTVIEW *) pNMHDR;
	int nItem = pLV->iItem;

	if (nItem == 0)	// üũڽ Ŭ
	{
		CHeaderCtrl* pHeadCtrl = m_lcUser.GetHeaderCtrl();

		if (pHeadCtrl == NULL)
			return;

		if (!pHeadCtrl->GetSafeHwnd())
			return;

		HDITEM hdItem;
		hdItem.mask = HDI_IMAGE;
		pHeadCtrl->GetItem(nItem, &hdItem);

		if (hdItem.iImage == 0)
			hdItem.iImage = 1;
		else
			hdItem.iImage = 0;

		pHeadCtrl->SetItem(nItem, &hdItem);

		BOOL bl = hdItem.iImage == 1 ? TRUE : FALSE;

		int nCount = m_lcUser.GetItemCount();
		
		for(nItem = 0; nItem < nCount; nItem++)
		{
			ListView_SetCheckState(m_lcUser.GetSafeHwnd(), nItem, bl);
		}
	}
	else
	{
		SORTPARAM sortParam;

		sortParam.bSortAscending = m_bSortAscending;
		sortParam.nSortColumn = nItem;

		m_lcUser.SortItems(SortFunc, (LPARAM)&sortParam);
		m_bSortAscending = !m_bSortAscending;
	}

	*pResult = 0;
}

int CALLBACK CAddUserDlg::SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	SORTPARAM *pSortParam = (SORTPARAM *)lParamSort;
	int nSortColumn = pSortParam->nSortColumn;
	bool bSortAscending = pSortParam->bSortAscending;

	int nRetVal = 0;

	CAddUserListData *pData1 = (CAddUserListData*)lParam1;
	CAddUserListData *pData2 = (CAddUserListData*)lParam2;

	switch (nSortColumn)
	{
	case 2: // ̸
		nRetVal = _tcscmp(pData1->GetMemberData().strName.c_str(), pData2->GetMemberData().strName.c_str());
		break;

	case 3: // μ
		nRetVal = _tcscmp(pData1->GetMemberData().strDept.c_str(), pData2->GetMemberData().strDept.c_str());
		break;

	case 4: // 
		if (_tcslen(pData1->GetMemberData().strJobPosCd.c_str()) > 0 && _tcslen(pData2->GetMemberData().strJobPosCd.c_str()) > 0)
			nRetVal = _tcscmp(pData1->GetMemberData().strJobPosCd.c_str(), pData2->GetMemberData().strJobPosCd.c_str());
		else
			nRetVal = _tcscmp(pData1->GetMemberData().strJobPos.c_str(), pData2->GetMemberData().strJobPos.c_str());
		break;

	default:
		break;
	}

	return bSortAscending ? nRetVal : -nRetVal;
}

LRESULT CAddUserDlg::OnGetUserStatus(WPARAM wParam,LPARAM lParam)
{
    CString *pStatus = (CString *)lParam;
    int nIndex = (int)wParam;
    if (nIndex < 0)
    {
        return false;
    }

    CAddUserListData *pListData =  (CAddUserListData *)m_lcUser.GetItemData(nIndex);
    if (pListData == NULL)
    {
        return false;
    }
    if (NULL != m_pModel)
    {
        const std::vector<ORG_MEMBER_DATA> memberVector = m_pModel->GetSelectedUserVector();
        for (size_t i = 0; i < memberVector.size(); i++)
        {
            if (pListData->GetUserID().Compare(memberVector[i].neMemberData.strUserId.c_str()) == 0)
            {
                *pStatus = GetPresenceTip(memberVector[i].eStatus);
            }
        }
    }

    return TRUE;
}